"{ Package: 'jv:libgdbs' }"

Object subclass:#GDBSessionRecorder
	instanceVariableNames:'record commandBuffer responseBuffer'
	classVariableNames:''
	poolDictionaries:'GDBDebugFlags'
	category:'GDB-Private-Simulator'
!

!GDBSessionRecorder methodsFor:'recording'!

recordCommand: command
    commandBuffer := WriteStream new.
    commandBuffer nextPutAll: command.

    "Created: / 22-06-2014 / 21:39:05 / Jan Vrany <jan.vrany@fit.cvut.cz>"
!

recordResponse: aString
    responseBuffer isNil ifTrue:[ 
        responseBuffer := CharacterWriteStream new.
    ].
    responseBuffer nextPutAll: aString

    "Created: / 22-06-2014 / 21:56:40 / Jan Vrany <jan.vrany@fit.cvut.cz>"
!

recordResponseChar: aCharacter
    responseBuffer isNil ifTrue:[ 
        responseBuffer := String new writeStream.
    ].
    responseBuffer nextPut: aCharacter

    "Created: / 22-06-2014 / 21:42:39 / Jan Vrany <jan.vrany@fit.cvut.cz>"
    "Modified: / 23-06-2014 / 09:23:42 / Jan Vrany <jan.vrany@fit.cvut.cz>"
!

recordResponseEnd
    | cmd resp |    

    record isNil ifTrue:[ 
        record := OrderedCollection new writeStream.
    ].

    commandBuffer notNil ifTrue:[
        cmd := commandBuffer contents.
        commandBuffer := nil.
    ].
    resp := responseBuffer contents.
    responseBuffer := nil.
    record nextPut: cmd -> resp.

    "Created: / 22-06-2014 / 21:54:01 / Jan Vrany <jan.vrany@fit.cvut.cz>"
    "Modified: / 23-06-2014 / 09:24:02 / Jan Vrany <jan.vrany@fit.cvut.cz>"
! !

